# Convoworks Prototype #

Convoworks Prototype is example application which utilizes ConwoWorks framework.


### Application overview ###

Convoworks Prototype has two main parts, Admin web and Public REST.

Admin web is a GUI for creating and managing services. It has own REST Api.  
Public REST application is for handling Amazon and Google ( FB Messenger, Viber, ...) requests and is not with auth.

From tehcnical perspective we have 2 apps

* GUI - AngularJs app
* REST - PHP app


##### PHP REST only configuration #####

Rename `common/__config.example.php` file into `common/__config.php`.

This should be done only on first installation. Because the working config files are not commited to Git, you can frelly pull changes and not overwrite your configuration.

### Docker ###

Navigate to ConvoWorksProto folder and run `docker-compose up`.
Gui will be on http://localhost:8080 and the REST on http://localhost:9090


##### Commands #####

    project_root# docker-compose up - starts containers
    project_root# docker-compose up webserver node - starts webserver and node container
    project_root# docker-compose up --build (webserver node)- re-builds and starts containers
    project_root# docker ps - lists running containers
    project_root# docker container stop webserver - stops container
    project_root# docker container stop $(docker container ls -aq)
    project_root# docker container rm $(docker container ls -aq)
    project_root# docker container rm $(docker container ls -aq) - deletes all containers

### Setting up for `ngrok` ###

Make sure you have registered for an account over at [the ngrok dashboard page](https://dashboard.ngrok.com/signup).

Once you have an account, take note of your authentication token. You can find it by selecting "Authentication"
from the left hand side menu, and then picking "Your Authtoken".

Create a file in the root of the project, next to where `docker-compose.yml` is, called `.env`

Put the following into your `.env` file:

```dotenv
NGROK_AUTH=<your_auth_token>
NGROK_SUBDOMAIN=<subdomain>
```

You may leave `NGROK_SUBDOMAIN` blank. Doing so will cause a new URL to be generated for you every time you run `docker-compose up`.

### Proto users ###

To utilize users in the proto installation, navigate to the folder `data/users`. Here you can find a file named `_users.example.json`. This file describes the structure of user objects. To start using your own users, create (or copy and rename the example file) `_users.json`.

Remember to take whatever password you wish to use for a given user and run it through the `md5` hash function, then store that hash (not the plain text) inside `_users.json`. You can hash your password using [this md5 hash generator](https://www.md5hashgenerator.com/).

### Imortant note for Linux users ###

If you are running docker with root, there should be no write permission issues. 
To avoid running it as root, follow these steps: https://docs.docker.com/engine/install/linux-postinstall/ 

### Imortant note for Windows users ###

If you experience any issues with abnormally slow requests, or any issues where Docker refuses to run or halts unexpectedly, consider adding an exclusion rule in Windows Security.

To add an exclude rule, follow these steps:

* Open your Start menu, and type in "Windows Security".
* Open the app.
* On the left hand side menu, choose "Virus & threat protection".
* In the right side window, under the "Virus & threat protection setings" section, click "Manage settings". 
* You might need to scroll down to the "Exclusions" section. Click on "Add or remove exclusions".
* Click the "Add an exclusion" button, and in the drop down menu that opens, select the "Folder" option.
* Locate the folder `C:\ProgramData\Docker` and add it as an exclusion.


## Upgrade procedure ##

Just unpack and deploy new package over your installation. Config and user files will not be overwriten.


